
;ScrollConsoleScreenBuffer example - dedndave - 7-2010
;note: row and column values are 0-based

        .XCREF
        .NOLIST
        INCLUDE  \masm32\include\masm32rt.inc
        .LIST

;----------------------------------------------------------------------------------------------------------

;to try different settings, change these values and re-assemble

NUMBEROFLINES2SCOLL   EQU 1
NUMBEROFTIMES2DOIT    EQU 3
TIMEBETWEENSCROLLS    EQU 2000  ;mS

;----------------------------------------------------------------------------------------------------------

        .DATA

        .DATA?

hStdOut               dd ?

;--------------------------

ScnBufInfo CONSOLE_SCREEN_BUFFER_INFO <>
; dwSize              COORD
;   x                   WORD
;   y                   WORD
;
; dwCursorPosition    COORD
;   x                   WORD
;   y                   WORD
;
; wAttributes         WORD
;
; srWindow            SMALL_RECT
;   Left                WORD
;   Top                 WORD
;   Right               WORD
;   Bottom              WORD
;
; dwMaximumWindowSize COORD
;   x                   WORD
;   y                   WORD

;--------------------------

ScrlRect   SMALL_RECT <>
; Left                WORD
; Top                 WORD
; Right               WORD
; Bottom              WORD

;--------------------------

CharInfo   CHAR_INFO <>
; Char                CHARTYPE (union)
;   UnicodeChar         WORD
;   (union)
;   AsciiChar           BYTE
; Attributes          WORD

;----------------------------------------------------------------------------------------------------------

        .CODE

_main   PROC

;get the standard handle for CONOUT$

        INVOKE  GetStdHandle,STD_OUTPUT_HANDLE
        mov     hStdOut,eax

;-----------------------------------------------

;start of demonstration loop

        print   chr$(13,10)
        push    NUMBEROFTIMES2DOIT

LoopStart:
        print   chr$('Some Text'),13

;-----------------------------------------------

;fill the console screen buffer structure

        INVOKE  GetConsoleScreenBufferInfo,hStdOut,offset ScnBufInfo

;-----------------------------------------------

;fill our scroll structures

;SCROLL RECTANGLE
;
;  The scroll rectangle structure describes the coordinates of the upper-left and
;lower-right corners of the display area that is to be copied (source). To scroll
;the entire display area, the left value is set to 0, and the top value is set to
;a value that is equal to the number of lines to be scrolled.

        mov word ptr ScrlRect.Left,0
        mov word ptr ScrlRect.Top,NUMBEROFLINES2SCOLL

;  For the bottom-right corner coordinate, we have an option. We may choose to scroll any
;text that may exist below the current cursor position (as in the example code). Or, we
;may choose to scroll only the text that is above the current cursor position. If we want
;to include the line of text where the cursor is, we set the bottom value to the same line
;as the current cursor position. If we wanted to exclude that line, we would subtract 1.

        mov     eax,dword ptr ScnBufInfo.srWindow.Right ;get bottom right corner of display window
        mov dword ptr ScrlRect.Right,eax                ;set bottom and right coordinates

;CLIPPING RECTANGLE
;
;  This example does not demonstrate the use of clipping, so the scroll
;rectangle structure values are also used for the clipping rectangle.

;DESTINATION ORIGIN
;
;  To scroll the entire display area, the destination origin is set to 0,0. This represents
;the destination coordinate of where the scroll rectangle text will be copied to.

;FILL CHARACTER
;
;  We also need to define the fill character and attribute. In this example, we use a unicode
;space character and the current default display attribute value is used for the fill attribute.

        mov word ptr CharInfo.Char.UnicodeChar,20h
        movzx   eax,word ptr ScnBufInfo.wAttributes
        mov     CharInfo.Attributes,ax

;-----------------------------------------------

;scroll by <NUMBEROFLINES2SCOLL> line(s)

        INVOKE  ScrollConsoleScreenBuffer,
                hStdOut,
                offset ScrlRect,
                offset ScrlRect,
                0,
                offset CharInfo

;-----------------------------------------------

;end of test loop

        pop     ecx
        dec     ecx
        jz      ExitProgram

        push    ecx
        INVOKE  Sleep,TIMEBETWEENSCROLLS
        jmp     LoopStart

;wait for a keypress and terminate

ExitProgram:
        print   chr$(13,10)
        inkey
        exit

_main   ENDP

;----------------------------------------------------------------------------------------------------------

        END     _main

